#include "menus.h"
#include "avr/eeprom.h"


void loadvars(void)
{
unsigned int i = 0;
	for(i = 0; i < menuamount; i++){
		vars[i] = eereadbyte((uint8_t*)(i));	//function for reading from eeprom
	
	}

}

void menurender(void)
{
char str[20];
unsigned int i = 0;
unsigned char j = 0;
//eewriteword((uint16_t*)(46), 0);
clearfunc();
	sprintf(str, "%3d", menulevel);

	if(((str[2]-48) == 0) && (dispmode == menu)){
	stringfunc(10,0,menucaptions[menulevel/10]);
	stringfunc(0,8,">");	

				//DEBUG!
	/*		sprintf(str, "%d", menulevel);
			FB_writestring(0,48,str);
			sprintf(str, "%d", menuselect);
			FB_writestring(0,56,str);
			sprintf(str, "%d", dispmode);
			FB_writestring(0,40,str); */

			if(menulevel == 0) stringfunc(10,0,maincaption);
			for(i = 0; i < LCD_Y/8-1; i++){
				
				if((menulevel+menuselect+i)<(menulevel+10) && (menulevel != 0)) stringfunc(6,8*(i+1),menucaptions[menulevel+menuselect+i]);
				if((menulevel == 0) && (menulevel+menuselect+i)<(menulevel+9))  stringfunc(6,8*(i+1),menucaptions[menulevel+menuselect+i+1]);
			}	
	return;
	}

	if(dispmode == editvar){
		stringfunc(5,0, "Editing setpoint");
		stringfunc(5,8,menucaptions[menulevel]);
		sprintf(str, "%d", vars[menulevel]);
		stringfunc(30,20,str);
	

				//DEBUG!
/*			sprintf(str, "%d", menulevel);
			FB_writestring(0,48,str);
			sprintf(str, "%d", menuselect);
			FB_writestring(0,56,str);
			sprintf(str, "%d", dispmode);
			FB_writestring(0,40,str); */
		return;
	
	}



	
	if(dispmode == editcurve){
		FB_drawline(15,0,15,55,0);
		FB_drawline(16,55,124,55,0);
		FB_drawline(15,64-vars[70],27,64-vars[71],0);
		FB_drawline(27,64-vars[71],39,64-vars[72],0);	
		FB_drawline(39,64-vars[72],51,64-vars[73],0);
		FB_drawline(51,64-vars[73],63,64-vars[74],0);
		FB_drawline(63,64-vars[74],75,64-vars[75],0);
		FB_drawline(75,64-vars[75],87,64-vars[76],0);
		FB_drawline(87,64-vars[76],99,64-vars[77],0);
		FB_drawline(99,64-vars[77],111,64-vars[78],0);
		FB_drawline(111,64-vars[78],124,64-vars[79],0);	
		
		for(i = 2; i < 7; i++){
			sprintf(str, "%d", i*10);
			stringfunc(2,60-i*10,str);
			FB_drawline(15,64-i*10,16,64-i*10,0);
			
			for(j = 28; j < 125; j+=12){

				FB_drawdot(j,64-i*10);
			}	
		}

		for(i = 28; i < 125; i+=12){

		FB_drawline(i,54,i,54,0);

		}

		stringfunc(9,56,menucaptions[70]);
		stringfunc(34,56,menucaptions[72]);
		stringfunc(62,56,menucaptions[74]);
		stringfunc(76,56,menucaptions[76]);
		stringfunc(101,56,menucaptions[78]);

		if(menulevel){
			FB_drawline(16+(menulevel-70)*12,55,16+(menulevel-70)*12,50,0);
			FB_drawline(16+(menulevel-70)*12,0,16+(menulevel-70)*12,5,0);
		
			if(menulevel <75){
				stringfunc((18+(menulevel-70)*12),46,menucaptions[menulevel]);
				sprintf(str, "%d", vars[menulevel]);
				stringfunc((18+(menulevel-70)*12),64-vars[menulevel]-8,str);
			}
		if(menulevel >74){
				stringfunc((((menulevel-70)*12)-3),46,menucaptions[menulevel]);
				sprintf(str, "%d", vars[menulevel]);
				stringfunc((((menulevel-70)*12)+2),64-vars[menulevel]-10,str);
			}

		}
	

	return;
	}

}


void keymanager(unsigned char key){	/* Manages all key presses */
char str[3];
	if(key == escape){
		if(menulevel == 0){
			dispmode = normal;
			menuselect = 0;
		}
		if((dispmode != editvar) && (dispmode != editcurve)){
		sprintf(str,"%3d",menulevel);
		
		menuselect = str[1]-49;
		//if(menuselect == 255) menuselect = 0;
		menulevel /= 10;
		}

		if(menulevel < 10) menulevel = 0;
		
		if(dispmode == editvar){
			vars[menulevel] = eereadbyte((uint8_t*)(menulevel));
			sprintf(str, "%3d", menulevel);
			menulevel = (str[1]-48)*10;
			dispmode = menu;
		return;	
		}

		if(dispmode == editcurve){
			if(menulevel > 69){
				menulevel--;
			
			}
			
			if(menulevel < 70){
			dispmode = normal;
			menulevel = 0;
			}
			return;
		}
	}	


	if((key == up) && (dispmode == menu) && (menuselect > 0)){
		menuselect--;
		return;
	}

	if((key == up) && ((dispmode == editvar) || (dispmode ==editcurve))){
	vars[menulevel]++;
		return;
	}
	
	if((key == down) && (dispmode == menu) && (menuselect < 9)){
		menuselect++;
		return;
	}

	if((key == down) && (dispmode == normal)){
		dispmode = editcurve;
		menulevel = 70;
		loadvars();
		return;
	}

	if((key == down) && ((dispmode == editvar) || (dispmode == editcurve))){
		vars[menulevel]--;
		return;
	}
	
	
	if(key == enter){
	
		if((dispmode != editvar) && (dispmode != editcurve)){
			if((menulevel == 0) && (dispmode == normal)){
				dispmode = menu;
				menuselect = 0;
				return;
			}

					
			if(menulevel > 9){
				dispmode = editvar;
				menulevel = menuselect+menulevel;
				return;
			}
	
			if(menulevel < 9){
				menulevel = (menuselect+1)*10;
				menuselect = 0;	
				return;
			}
		}
		if(dispmode == editvar){
			eewritebyte((uint8_t*)(menulevel), vars[menulevel]); //Function for saving to eeprom
			sprintf(str, "%3d", menulevel);
			menulevel = (str[1]-48)*10;
			dispmode = menu;
			return;	
		}
	
		if(dispmode == editcurve){
			eewritebyte((uint8_t*)(menulevel), vars[menulevel]);
			if(menulevel < 80){ 
				menulevel++;
			
			}

			if(menulevel > 79){
				menulevel = 0;
				dispmode = normal;
			}
		}
	

	}


}
